Subject: Re: bug#11302: Automake 1.11d on openSUSE 12.1

From: Stefano Lattarini <[email-masked]>
Date: Sun, 22 Apr 2012 22:35:31 +0200

On 04/22/2012 07:42 PM, Bruno Haible wrote:
> Hi Stefano,
> 
>>> FAIL: t/depcomp2
>>> ================
>>>
>>> [SNIP]
>>> ...
>>> The file 'stderr' is not empty: It contains this two-line warning
>>>
>>>   configure: WARNING: if you wanted to set the --build type, don't use --host.
>>>       If a cross compiler is detected then cross compile mode will be used
>>>
>>> This is because I configured with the arguments
>>>
>>>   --host=x86_64-pc-linux-gnu \
>>>   --prefix=/home/bruno/data/build/prefix-linux-x86_64 \
>>>   --libdir=/home/bruno/data/build/prefix-linux-x86_64/lib64
>>>
>>> Apparently this led to a host_alias variable being passed to sub-configures:
>>>
>> The autoconf manual reads:
>>
>>     For historical reasons, whenever you specify --host, be sure to specify
>>     --build too; this will be fixed in the future.
> 
> It is safer for me in general to never use --build, only --host.
> config.guess is always doing its job right [1]; if I used --build, I would
> only increase the risk of mistakes. 
>
Not if you do something like this:

  ./configure --host=whatever --build="`./lib/config.status`"

>> Does the error disappear if you also pass the '--build' option to configure?
> 
> The Autoconf manual says "this will be fixed in the future"; therefore
> the Automake test suite should be prepared to work with just --host and no
> --build option.
>
Well, the text in t/README is quite clear in explaining what you have to do if
you want to run the testsuite with a cross compiler:

  For example, to run with a Linux-to-MinGW cross compiler, you will need
  something like this:

    ./configure --host i586-mingw32msvc --build i686-pc-linux-gnu

  To avoid possible spurious error, you really have to *explicitly* specify
  '--build' in addition to '--host'; the 'lib/config.guess' script can help
  determine the correct value to pass to '--build'.

And I see that you've also already proposed a patch to fix the situation in
autoconf proper (which is the best thing to do IMHO).  So consider this part
of the report labelled as a "wontfix".  I will reply to the rest of the
report tomorrow.

Thanks,
  Stefano